
; 2005: Sept 19 - Read SIZ from separate file

; IDL CODE TO FIND LUMINOSITY DISTANCE FACTOR FOR THE SOURCES
;  (BY INTEGRATING OVER z) EQ. (3.76) OF PEACOCK

	function intgr, x
           om_M = 0.3
           om_V = 0.7
           temp = sqrt(om_V + om_M * ((1+x)^3) )
           return, 1.0/temp
        end

	pro find_DL_7C

	print, ' In "find_DL_7C.pro"'

;	SIZ = 17454       ; for BRW (initial sampsize of 2096199)

        SIZarr = lonarr(3)
; READ NUMBER OF LINES IN FILE 'tbirztageQ_7C.dat' FROM 'SampSize3C6C7C.dat'
	openr, 1, '../../SampSize3C6C7C.dat'; Open the file
	readf, 1, SIZarr                    ; Read number of lines written in 'SampSize3C6C7C.dat'
	close, 1
	
	SIZ = SIZarr[2]
;	print, ' SIZ =', SIZ, ', SIZarr =', SIZarr

	ZlogP = dblarr(4, SIZ)  ; CHECK SIZE OF logP*.dat & GIVE
        openr, 1, 'tbirztageQ_7C.dat'
        readf, 1, ZlogP
        close, 1
 
        z = ZlogP(1, *)

	print, 'Data read, getting Qromb'
	
	effec_d = QROMB('intgr', 0.0, z)

	openw, 2, 'effec_dist_7C.dat'

	c = 2.9979e5            ; speed of light in km/s
	H0 = 71.000             ; Hubble constant in km/sec/Mpc.
	mpermpc = 3.0857e22       ; number of meters in a Mpc.

	for i = 0L, SIZ - 1 do begin
	    printf, 2, z(i), (c/H0)*effec_d(i)*mpermpc
; WRITE z & EFFECTIVE DISTANCE (IN m) IN FILE 'effec_dist.dat' 
;	    print, 'run =', i 
	endfor

	close, 2

	return
	end
