; CODE TO PICK UP ~ 145 OBJECTS FROM ALL THOSE DETECTED IN ALL THE SAMPLE TEST RUNS 
; & DO THE STAT TEST & DO THE PLOTTING OF PDza PLANES
; 2004 Sept 20: Paramita
; Nov 15: Corrected to REST FRAME OF SOURCE ..

; 2005 Apr 13: Modified & made more correct (perhaps!). Pick D_sim & alpha_sim from 
; model prediction, equal in number to 7CIII sources, as comparing to D_obs & 
; alpha_obs for 7CIII only. Pick P_sim & z_sim for all 7CI+II+III sources.
; July 21: Modify in order to combine all codes 
; Dec 02: Modify path & Size of 7C data after updating data to exlude FRI's. 

	pro small_test_7C

	print, ' In "small_test_7C.pro"'

        SIZarr = intarr(2)
; READ NUMBER OF LINES IN FILE 'zTageQlogPem_noSmallD.dat' FROM 'SIZ_det.dat'
        openr, 1, 'SIZ_det.dat'    ; Open the file
        readf, 1, SIZarr           ; Read number of lines as written in 'SIZ_det.dat'
        close, 1         
	S = SIZarr[1]

        alldata = DBLARR(4, S)      ; TOTAL SIZE / TOTAL # OF SOURCES DETECTED
	openr, 1, '7Cres/PDza_all.dat'
        readf, 1, alldata
        close, 1
        P_sim1 = alldata(0, *)
	D_proj_BRW = alldata(1, *)
	z_sim1 = alldata(2, *)
        a_sim1 = alldata(3, *)

	alldata = DBLARR(3, S)      ; TOTAL SIZE / TOTAL # OF SOURCES DETECTED
	openr, 1, '7Cres/zTageQ_all.dat'
        readf, 1, alldata
        close, 1
        Tage_sim1 = alldata(1, *)
        Q_sim1 = alog10(alldata(2, *))

	S_7C_all = 126                   ; SIZE OF 7C (I + II + III) DATA SET
        S_7C_III = 52                   ; SIZE OF 7C III DATA SET

        data_obs_all = DBLARR(2, S_7C_all) 
; openr, 1, '/nfs/morgan2/barai/Paul_Work/mao_idl2c/DATA/7CRS/SourceREST/pz_7C_all.dat' 
openr, 1, '/nfs/morgan2/barai/Paul_Work/mao_idl2c/DATA/7CRS/SourceREST/noFR1/pz_7C_all.dat'
        readf, 1, data_obs_all
        close, 1
        P_obs = data_obs_all(0, *)
        z_obs = data_obs_all(1, *)

        data_obsIII = DBLARR(4, S_7C_III)
; openr, 2, '/nfs/morgan2/barai/Paul_Work/mao_idl2c/DATA/7CRS/7CIII/SourceREST/P151rest_Dproj_z_a151rest_OBS_7CIII.dat' 
openr, 2, '/nfs/morgan2/barai/Paul_Work/mao_idl2c/DATA/7CRS/7CIII/SourceREST/noFR1/P151rest_Dproj_z_a151rest_OBS_7CIII.dat'
        readf, 2, data_obsIII
        close, 2
        D_obs = data_obsIII(1, *)
        a_obs = data_obsIII(3, *)

; NOW FROM THIS BIG SUPER SAMPLE (COMBINAITON OF ALL OBJECTS THAT WERE DETECTED IN ALL RUNS)
; PICK UP 145 OBJECTS RANDOMLY & PLOT THEM CONSIDERING THAT AS OUR FINAL 3C MODEL PREDICTION

        siz = double(S)        ; SIZE OF BIG SAMPLE
        siz_Pz = (siz/S_7C_all)   ; LENGTH OF INTERVAL NEEDED TO PICK UP AN OBJECT FROM THE BIG SAMPLE, for P & z comparison only (ie. all 7C I+II+III samples) ..
        counter_Pz = dblarr(S_7C_all+1) & j = 0
        for i=0, S_7C_all do begin
           counter_Pz[j] = siz_Pz*j  ; INDICES OF AFTER HOW MUCH INTERVAL NEED TO PICK UP AN OBJECT FROM THE BIG SAMPLE (to compare P & z only) ..
           j = j+1
        endfor

	siz_Da = (siz/S_7C_III)   ; LENGTH OF INTERVAL NEEDED TO PICK UP AN OBJECT FROM THE BIG SAMPLE, for D & a comparison only (ie. only 7C III sample) ..
	counter_Da = dblarr(S_7C_III+1) & j = 0
        for i=0, S_7C_III do begin
           counter_Da[j] = siz_Da*j  ; INDICES OF AFTER HOW MUCH INTERVAL NEED TO PICK UP AN OBJECT FROM THE BIG SAMPLE (to compare D & a only) ..
           j = j+1
        endfor

        ; SORTING SAMPLES IN ASCENDING ORDER IN z
        P_sim1_sorted = P_sim1(SORT(z_sim1))
        ;D_sim1_sorted = D_sim1(SORT(z_sim1))
        D_proj_BRW_sorted = D_proj_BRW(SORT(z_sim1))
        z_sim1_sorted = z_sim1(SORT(z_sim1))
        a_sim1_sorted = a_sim1(SORT(z_sim1))
        Q_sim1_sorted = Q_sim1(SORT(z_sim1))
        Tage_sim1_sorted = Tage_sim1(SORT(z_sim1))

	; PICK UP THE RANDOM SAMPLE FROM THE BIG VERSION
        Psmall_Pz = P_sim1_sorted(counter_Pz)
	zsmall_Pz = z_sim1_sorted(counter_Pz)
	Qsmall_Pz = Q_sim1_sorted(counter_Pz)
        Tagesmall_Pz = Tage_sim1_sorted(counter_Pz)

	Psmall_Da = P_sim1_sorted(counter_Da)
        Dproj_BRWsmall_Da = D_proj_BRW_sorted(counter_Da)
        zsmall_Da = z_sim1_sorted(counter_Da)
        asmall_Da = a_sim1_sorted(counter_Da)

        ; INDICES / SUBSCRIPTS OF ORIGINAL FILE "padqtz_super.dat" WHICH ARE PICKED
        ;print, '(sort(z_sim1))(counter) =', (sort(z_sim1))(counter)+1

	openw, 1, '7Cres/pz_small.dat'
	for i=0, S_7C_all do printf, 1, Psmall_Pz[i], zsmall_Pz[i]
	close, 1

	openw, 1, '7Cres/padz_for_ad_small.dat'
	for i=0, S_7C_III do printf, 1, Psmall_Da[i], asmall_Da[i], Dproj_BRWsmall_Da[i], zsmall_Da[i]
	close, 1

	print, 'IDL K-S TEST RESULTS : COMPARISON OF 7C DATA W/ BRW (change r_hs) MODEL PREDICTION - COMBINING ALL SAMPLES ( detected)'
        kstwo, P_sim1, P_obs, DKS_P, prob_P
        print, 'SOURCE POWER  : prob_P = ', prob_P
        kstwo, D_proj_BRW, D_obs, DKS_D_BRW, prob_D_BRW
        print, 'SIZE_PROJ_BRW : prob_D = ', prob_D_BRW
        kstwo, z_sim1, z_obs, DKS_z, prob_z
        print, 'REDSHIFT      : prob_z = ', prob_z
        kstwo, a_sim1, a_obs, DKS_a, prob_a
        print, 'SPECTRAL INDEX: prob_a = ', prob_a

	openu, 2, '../KSprob_PDza_TOTALsmall_3C6C7C.dat', /APPEND
        printf, 2, prob_P, prob_D_BRW, prob_z, prob_a

	print, 'IDL K-S TEST RESULTS : COMPARISON OF 7C DATA W/ BRW (change r_hs) MODEL PREDICTION - OBJECTS PICKED RANDOMLY FROM BIG SAMPLE'
        kstwo, Psmall_Pz, P_obs, DKS_P, prob_P
        print, 'SOURCE POWER  : prob_P = ', prob_P
        kstwo, Dproj_BRWsmall_Da, D_obs, DKS_D_BRW, prob_D_BRW
        print, 'SIZE_PROJ_BRW : prob_D = ', prob_D_BRW
        kstwo, zsmall_Pz, z_obs, DKS_z, prob_z
        print, 'REDSHIFT      : prob_z = ', prob_z
        kstwo, asmall_Da, a_obs, DKS_a, prob_a
        print, 'SPECTRAL INDEX: prob_a = ', prob_a

	printf, 2, prob_P, prob_D_BRW, prob_z, prob_a
        close, 2

	zlt08_ind = WHERE((zsmall_Pz LT 0.8), count_zlt08_Pz) 
	if (count_zlt08_Pz NE 0) then begin 
	   zlt08_Pz = zsmall_Pz(zlt08_ind) & plt08_Pz = Psmall_Pz(zlt08_ind)
	   qlt08_Pz = Qsmall_Pz(zlt08_ind) & tlt08_Pz = Tagesmall_Pz(zlt08_ind)
	endif

	zlt08_ind = WHERE((zsmall_Da LT 0.8), count_zlt08_Da)
	if (count_zlt08_Da NE 0) then begin
	   zlt08_Da = zsmall_Da(zlt08_ind)         & plt08_Da = Psmall_Da(zlt08_ind)
           dlt08_Da = Dproj_BRWsmall_Da(zlt08_ind) & alt08_Da = asmall_Da(zlt08_ind) 
	endif

        z08t15_ind = WHERE( ((zsmall_Pz GE 0.8) AND (zsmall_Pz LT 1.5)), count_z08t15_Pz )
	if (count_z08t15_Pz NE 0) then begin 
	   z08t15_Pz = zsmall_Pz(z08t15_ind) & p08t15_Pz = Psmall_Pz(z08t15_ind)
	   q08t15_Pz = Qsmall_Pz(z08t15_ind) & t08t15_Pz = Tagesmall_Pz(z08t15_ind) 
	endif

	z08t15_ind = WHERE( ((zsmall_Da GE 0.8) AND (zsmall_Da LT 1.5)), count_z08t15_Da ) 
	if (count_z08t15_Da NE 0) then begin
	   z08t15_Da = zsmall_Da(z08t15_ind)         & p08t15_Da = Psmall_Da(z08t15_ind)
           d08t15_Da = Dproj_BRWsmall_Da(z08t15_ind) & a08t15_Da = asmall_Da(z08t15_ind) 
	endif
	
        z15t2_ind = WHERE( ((zsmall_Pz GE 1.5) AND (zsmall_Pz LT 2.0)), count_z15t2_Pz )
	if (count_z15t2_Pz NE 0) then begin 
	   z15t2_Pz = zsmall_Pz(z15t2_ind) & p15t2_Pz = Psmall_Pz(z15t2_ind)
	   q15t2_Pz = Qsmall_Pz(z15t2_ind) & t15t2_Pz = Tagesmall_Pz(z15t2_ind) 
	endif

	z15t2_ind = WHERE( ((zsmall_Da GE 1.5) AND (zsmall_Da LT 2.0)), count_z15t2_Da )
	if (count_z15t2_Da NE 0) then begin 
	   z15t2_Da = zsmall_Da(z15t2_ind)         & p15t2_Da = Psmall_Da(z15t2_ind)
           d15t2_Da = Dproj_BRWsmall_Da(z15t2_ind) & a15t2_Da = asmall_Da(z15t2_ind) 
	endif

        zgt2_ind = WHERE((zsmall_Pz GE 2.0), count_zgt2_Pz) 
	if (count_zgt2_Pz NE 0) then begin 
	   zgt2_Pz = zsmall_Pz(zgt2_ind) & pgt2_Pz = Psmall_Pz(zgt2_ind)
	   qgt2_Pz = Qsmall_Pz(zgt2_ind) & tgt2_Pz = Tagesmall_Pz(zgt2_ind) 
	endif

	zgt2_ind = WHERE((zsmall_Da GE 2.0), count_zgt2_Da) 
	if (count_zgt2_Da NE 0) then begin
	   zgt2_Da = zsmall_Da(zgt2_ind)         & pgt2_Da = Psmall_Da(zgt2_ind)
           dgt2_Da = Dproj_BRWsmall_Da(zgt2_ind) & agt2_Da = asmall_Da(zgt2_ind)
	endif

	Dmin = MIN(Dproj_BRWsmall_Da) & Dmax = MAX(Dproj_BRWsmall_Da)
	print, ' Dmin = ', Dmin, ' kpc', ' & Dmax = ', Dmax, ' kpc'
	if (Dmin GT 1.0) then Dmin = 1.0

	!p.font = 0
        !P.MULTI = [0, 2, 2]
        set_plot, 'ps'
        device, filename='7Cres/PDza1.ps', /landscape
        !x.thick = 3
        !y.thick = 3
        !p.thick = 2
        !p.charsize = 1.1

        !x.title = 'Redshift, z'
        !y.title = 'Log!D10!N(P!D151!N / W Hz!U-1!N sr!U-1!N)'
        !x.range = [0, 4]
        !x.style = 1
        !y.range = [24, 30]
        !y.style = 1 
	plot, zsmall_Pz, Psmall_Pz, /nodata, title = 'Predicted 7C: BRW (Vary r_hs)'
        if (count_zlt08_Pz NE 0) then oplot, zlt08_Pz, plt08_Pz, psym = 1, symsize = 0.5
        if (count_z08t15_Pz NE 0) then oplot, z08t15_Pz, p08t15_Pz, psym = 5
        if (count_z15t2_Pz NE 0) then oplot, z15t2_Pz, p15t2_Pz, psym = 7
        if (count_zgt2_Pz NE 0) then oplot, zgt2_Pz, pgt2_Pz, psym = 2 

        !x.title = 'Projected Linear Size, D (kpc)'
        !y.title = 'Log!D10!N(P!D151!N / W Hz!U-1!N sr!U-1!N)'
        !x.range = [Dmin, 100000]
        !x.style = 1
        !y.range = [24, 30]
        !y.style = 1 
plot, Dproj_BRWsmall_Da, Psmall_Da, /nodata, /xlog, title ='Random  126 for 7Call & 52 for 7CIII only' 
        if (count_zlt08_Da NE 0) then oplot, dlt08_Da, plt08_Da, psym = 1, symsize = 0.5 
	if (count_z08t15_Da NE 0) then oplot, d08t15_Da, p08t15_Da, psym = 5
        if (count_z15t2_Da NE 0) then oplot, d15t2_Da, p15t2_Da, psym = 7
        if (count_zgt2_Da NE 0) then oplot, dgt2_Da, pgt2_Da, psym = 2

        !x.title = 'Spectral Index, a'
        !y.title = 'Log!D10!N(P!D151!N / W Hz!U-1!N sr!U-1!N)'
        !x.range = [0, 2]
        !x.style = 1
        !y.range = [24, 30]
        !y.style = 1 
	plot, asmall_Da, Psmall_Da, /nodata 
	if (count_zlt08_Da NE 0) then oplot, alt08_Da, plt08_Da, psym = 1, symsize = 0.5
        if (count_z08t15_Da NE 0) then oplot, a08t15_Da, p08t15_Da, psym = 5
        if (count_z15t2_Da NE 0) then oplot, a15t2_Da, p15t2_Da, psym = 7
        if (count_zgt2_Da NE 0) then oplot, agt2_Da, pgt2_Da, psym = 2

	!x.title = 'Redshift, z'
        !y.title = 'Projected Linear Size, D (kpc)'
        !x.range = [0, 4]
        !x.style = 1
        !y.range = [Dmin, 100000]
        !y.style = 1 
	plot, zsmall_Da, Dproj_BRWsmall_Da, /nodata, /ylog
        if (count_zlt08_Da NE 0) then oplot, zlt08_Da, dlt08_Da, psym = 1, symsize = 0.5
        if (count_z08t15_Da NE 0) then oplot, z08t15_Da, d08t15_Da, psym = 5
        if (count_z15t2_Da NE 0) then oplot, z15t2_Da, d15t2_Da, psym = 7
        if (count_zgt2_Da NE 0) then oplot, zgt2_Da, dgt2_Da, psym = 2

        device, /close

        device, filename='7Cres/PDza2.ps', /landscape
        !x.title = 'Projected Linear Size, D (kpc)'
        !y.title = 'Spectral Index'
        !x.range = [Dmin, 100000]
        !x.style = 1
        !y.range = [0, 2]
        !y.style = 1 
	plot, Dproj_BRWsmall_Da, asmall_Da, /nodata, /xlog, title = 'Predicted 7C: BRW (Vary r_hs)'
        if (count_zlt08_Da NE 0) then oplot, dlt08_Da, alt08_Da, psym = 1, symsize = 0.5
        if (count_z08t15_Da NE 0) then oplot, d08t15_Da, a08t15_Da, psym = 5
        if (count_z15t2_Da NE 0) then oplot, d15t2_Da, a15t2_Da, psym = 7
        if (count_zgt2_Da NE 0) then oplot, dgt2_Da, agt2_Da, psym = 2

        !x.title = 'Redshift, z'
        !y.title = 'Spectral Index'
        !x.range = [0, 4]
        !x.style = 1
        !y.range = [0, 2]
        !y.style = 1 
	plot, zsmall_Da, asmall_Da, /nodata, title ='Random  126 for 7Call & 52 for 7CIII only'
        if (count_zlt08_Da NE 0) then oplot, zlt08_Da, alt08_Da, psym = 1, symsize = 0.5
        if (count_z08t15_Da NE 0) then oplot, z08t15_Da, a08t15_Da, psym = 5
        if (count_z15t2_Da NE 0) then oplot, z15t2_Da, a15t2_Da, psym = 7
        if (count_zgt2_Da NE 0) then oplot, zgt2_Da, agt2_Da, psym = 2

	!x.title = 'log!D10!N[ Jet Power (W) ]'
        !y.title = 'Log!D10!N(P!D151!N / W Hz!U-1!N sr!U-1!N)'
        !x.range = [36, 42]
        !x.style = 1
        !y.range = [24, 30]
        !y.style = 1 
	plot, Qsmall_Pz, Psmall_Pz, /nodata
        if (count_zlt08_Pz NE 0) then oplot, qlt08_Pz, plt08_Pz, psym = 1, symsize = 0.5
        if (count_z08t15_Pz NE 0) then oplot, q08t15_Pz, p08t15_Pz, psym = 5
        if (count_z15t2_Pz NE 0) then oplot, q15t2_Pz, p15t2_Pz, psym = 7
        if (count_zgt2_Pz NE 0) then oplot, qgt2_Pz, pgt2_Pz, psym = 2 

        !x.title = 'Redshift'
        !y.title = 'Age (Years)'
        !x.range = [0, 4]
        !x.style = 1
        !y.range = [1.e4, 1.e9]
        !y.style = 1 
	plot, zsmall_Pz, Tagesmall_Pz*1.0e6, /nodata, /ylog
        if (count_zlt08_Pz NE 0) then oplot, zlt08_Pz, tlt08_Pz*1.0e6, psym = 1, symsize = 0.5
        if (count_z08t15_Pz NE 0) then oplot, z08t15_Pz, t08t15_Pz*1.0e6, psym = 5
        if (count_z15t2_Pz NE 0) then oplot, z15t2_Pz, t15t2_Pz*1.0e6, psym = 7
        if (count_zgt2_Pz NE 0) then oplot, zgt2_Pz, tgt2_Pz*1.0e6, psym = 2

        device, /close

        set_plot, 'x'
        !p.multi = 0

	return
	end
